<template>
  <div class="AppError">
    <h1 class="title">Initialization Error</h1>
    <span class="message">{{ error.message }}</span>
    <div v-if="error.actions" class="actions">
      <button
        v-for="(action, idx) in error.actions"
        :key="idx"
        class="action"
        @click="action.run"
      >
        <span class="action__title"> {{ action.name }}</span>
        <span class="action__label"> {{ action.label }}</span>
      </button>
    </div>
    <h2 class="title">Details</h2>
    <span class="stack">{{ error }}</span>
  </div>
</template>

<script lang="ts" setup>
import { Action } from '@/types'

defineProps<{
  error: {
    message: string
    actions?: Action[]
  }
}>()
</script>

<style lang="scss" scoped>
* {
  box-sizing: border-box;
}

.AppError {
  display: flex;
  flex-direction: column;
  flex-wrap: wrap;
  width: 100vw;
  height: 100vh;
  font-family: sans-serif;
}

.actions {
  padding: 10px;
}

.action {
  $color: #b82b00;

  display: inline-flex;
  flex-wrap: wrap;
  padding: 5px;
  border: 1px solid $color;
  border-radius: 5px;
  color: $color;

  &:hover {
    background-color: $color;
    color: #fff;
  }
}

.action__title {
  flex: 1 1 100%;
  font-weight: bold;
}

.action__label {
  flex: 1 1 100%;
  font-style: italic;
}
</style>
